#!/usr/bin/env python
#
# Copyright (c) 2001, 2002, 2003, 2004 The SCons Foundation
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
# KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
# WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
#

__revision__ = "/home/scons/scons/branch.0/baseline/test/redirection.py 0.96.1.D001 2004/08/23 09:55:29 knight"

import os
import TestSCons

python = TestSCons.python

test = TestSCons.TestSCons()

test.write('cat.py', r"""
import sys
try:
    input = open(sys.argv[1], 'r').read()
except IndexError:
    input = sys.stdin.read()
sys.stdout.write(input)
sys.exit(0)
""")

test.write('SConstruct', r"""
env = Environment()
env.Command(target='foo1', source='bar1',
            action= '%s cat.py $SOURCES > $TARGET')
env.Command(target='foo2', source='bar2',
            action= '%s cat.py < $SOURCES > $TARGET')
env.Command(target='foo3', source='bar3',
            action='%s cat.py $SOURCES | %s cat.py > $TARGET')
env.Command(target='foo4', source='bar4',
            action='%s cat.py <$SOURCES |%s cat.py >$TARGET')
""" % (python, python, python, python, python, python))

test.write('bar1', 'bar1\r\n')
test.write('bar2', 'bar2\r\n')
test.write('bar3', 'bar3\r\n')
test.write('bar4', 'bar4\r\n')

test.run(arguments='.')

test.fail_test(test.read('foo1') != 'bar1\r\n')
test.fail_test(test.read('foo2') != 'bar2\r\n')
test.fail_test(test.read('foo3') != 'bar3\r\n')
test.fail_test(test.read('foo4') != 'bar4\r\n')

test.pass_test()

